import java.util.*;
import ecs100.*;
import java.awt.Color;

public class Graph{
    public static final double X_AXIS_YPOS = 250;
    public static final double Y_AXIS_XPOS = 50;

    //Draw a graph of numbers provided by a user
    public void drawGraph(){
        ArrayList<Double> list = UI.askNumbers("List of numbers between 0 - 200 (end with 'done')");
        drawGraph(list,Y_AXIS_XPOS,X_AXIS_YPOS,10);
    }

    //Draws a graph for a list of numbers (Y-axis show values in string)
    //(xBound,yBound) is (0,0) in the coordinate system
    //xDist is the distance between each number in the graph
    //Draw lines between the points on the graph
    //This should only draw a graph when there is more than 1 number in the graph
    //Add a circle around maximum value
    public void drawGraph(ArrayList<Double> list, double xBound, double yBound, double xDist)  {
        //Clear the screen, so there is no old graphs
        UI.clearGraphics();
        
        //Draw axis
        UI.drawLine(xBound, yBound, xBound+450, yBound);
        UI.drawLine(xBound, yBound, xBound, 0);
        
        // Setup previous position
        double prevX = xBound;
        double prevY = yBound;
        
        // Loop over all values
        for(double num: list){
            UI.setColor(Color.black);
            double newX = prevX + xDist;
            double newY = yBound - num;
            UI.drawLine(prevX, prevY, newX, newY);
            if(num == this.findMin(list)){
                UI.setColor(Color.blue);
                UI.fillOval(newX-5, newY-5, 10, 10);
            }
            prevX = newX;
            prevY = newY;
        }

        double avg = this.average(list);
        UI.setColor(Color.red);
        UI.drawLine(xBound, yBound-avg, xBound+450, yBound-avg);
        
        // Find average and draw line
        
        
    }

    public double average(ArrayList<Double> l) {
        double  total = 0.0;
        double count= 0 ;
        for(double num: l){
            total = total+num;
            count++;
        }
        return total/l.size(); // total/count
    }

    public double findMin(ArrayList<Double> list){
        double  min = Double.POSITIVE_INFINITY;
        for(double num: list){
            if(num<min){
                min = num;
            }
        }
        return min; 
    }

    public void setupGUI(){
        UI.addButton("Draw graph", this::drawGraph);
        UI.addButton("Clear",UI::clearPanes);
        UI.addButton("Quit", UI::quit);
    }

    public static void main(String[] str){
        Graph t = new Graph();
        t.setupGUI();
    }
}
